VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmBar 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00E0E0E0&
   BorderStyle     =   0  'Kein
   ClientHeight    =   5130
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5085
   LinkTopic       =   "Form1"
   ScaleHeight     =   5130
   ScaleWidth      =   5085
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox Picture2 
      Align           =   1  'Oben ausrichten
      BackColor       =   &H00E0E0E0&
      Height          =   4335
      Left            =   0
      ScaleHeight     =   4275
      ScaleWidth      =   5025
      TabIndex        =   3
      Top             =   465
      Width           =   5085
      Begin VB.CommandButton cmdModify 
         Caption         =   "&Modify"
         Height          =   330
         Left            =   4050
         TabIndex        =   7
         Top             =   3870
         Width           =   825
      End
      Begin VB.TextBox txtValue 
         Height          =   330
         Left            =   675
         TabIndex        =   6
         Top             =   3870
         Width           =   3345
      End
      Begin MSComctlLib.TreeView TV1 
         Height          =   2715
         Left            =   135
         TabIndex        =   5
         Top             =   315
         Width           =   4785
         _ExtentX        =   8440
         _ExtentY        =   4789
         _Version        =   393217
         Indentation     =   529
         LabelEdit       =   1
         Style           =   4
         FullRowSelect   =   -1  'True
         SingleSel       =   -1  'True
         Appearance      =   1
      End
      Begin VB.Label lblValue 
         BackStyle       =   0  'Transparent
         Caption         =   "Value:"
         Height          =   330
         Left            =   135
         TabIndex        =   8
         Top             =   3870
         Width           =   555
      End
      Begin VB.Label Label2 
         BackStyle       =   0  'Transparent
         Caption         =   "Active Property Table"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   240
         Left            =   90
         TabIndex        =   4
         Top             =   45
         Width           =   3210
      End
   End
   Begin VB.PictureBox Picture1 
      Align           =   1  'Oben ausrichten
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'Kein
      Height          =   465
      Left            =   0
      ScaleHeight     =   465
      ScaleWidth      =   5085
      TabIndex        =   0
      Top             =   0
      Width           =   5085
      Begin VB.CommandButton cmdOpen 
         Height          =   315
         Left            =   4500
         Picture         =   "frmBar.frx":0000
         Style           =   1  'Grafisch
         TabIndex        =   9
         ToolTipText     =   "Apri direttamente la cartella di rete con i profili campi"
         Top             =   90
         Width           =   450
      End
      Begin VB.TextBox txtFile 
         Appearance      =   0  '2D
         BackColor       =   &H00E0E0E0&
         Height          =   285
         Left            =   450
         Locked          =   -1  'True
         TabIndex        =   1
         Top             =   90
         Width           =   3975
      End
      Begin VB.Label Label1 
         Caption         =   "File:"
         Height          =   195
         Left            =   90
         TabIndex        =   2
         Top             =   135
         Width           =   330
      End
   End
End
Attribute VB_Name = "frmBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'SE Application Interface
Private m_oApp As SolidEdgeFramework.Application
Private m_oDoc As Object 'Polymorphic ActiveDocument
Public hEdgeBarWnd As Long 'HWND of the parent (edgebar pane)

Private m_ActiveClass As String
Private m_ActiveProperty As String

''
'' STANDARD INTERFACE FOR SOLID EDGE INTERACTION
''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'Called only ONE TIME at initialization
Public Sub InitForm(oSEApp As SolidEdgeFramework.Application, theDocument As Object)
    DBG "Addin: InitForm for " & GetSafeDocName(theDocument)
    
    On Error GoTo fail
    
    'Store the application object for internal use
    Set m_oApp = oSEApp
    
    'Store the document object for internal use
    Set m_oDoc = theDocument
    
    'Refresh the pane interface
    RefreshFileName
    RefreshPropertyTree
    
    Exit Sub
fail:
    ErrHandler "initForm"
End Sub

''''''''''''''''
''''''''''''''''
''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub RefreshFileName()
    On Error GoTo fail
    
10  If m_oDoc Is Nothing Then
        txtFile.Text = ""
        cmdOpen.Enabled = False
    Else
        'Retrieve the current FullName
20      txtFile.Text = " " & m_oDoc.FullName
        If InStr(1, txtFile.Text, ".") > 0 Then
            cmdOpen.Enabled = True
        Else
            'Disable open button if the file does not have
            'any extension, i.e. it's a new file never saved before
            cmdOpen.Enabled = False
        End If
    End If
    Exit Sub
fail:
    ErrHandlerRaise "RefreshFilename"
End Sub

Private Sub RefreshPropertyTree()
    On Error GoTo fail
    
    Dim oProperties As SolidEdgeFramework.Properties
    Dim oPropSets As SolidEdgeFramework.PropertySets
    Dim oProperty As SolidEdgeFramework.Property
    
    Dim sParentKey As String
    Dim sPropKey As String
    Dim sPropText As String
    
10  TV1.Nodes.Clear
    txtValue.Text = ""
    m_ActiveClass = ""
    m_ActiveProperty = ""
  
    If m_oDoc Is Nothing Then Exit Sub
  
    'Get the collection of propertysets
20  Set oPropSets = m_oDoc.Properties
    
    'Cycle on propertysets collection to retrieve all property classes
30  For Each oProperties In oPropSets
        
        'Add the root tree subnode for this propertyset
40      sParentKey = oProperties.Name
        sPropText = "[" & oProperties.Name & "]"
50      TV1.Nodes.Add , , sParentKey, sPropText
    
        'Cycle on properties collection to retrieve any single property
60      For Each oProperty In oProperties
            
            'Add the property node as child
70          sPropKey = sParentKey & "|" & oProperty.Name
            sPropText = oProperty.Name & "=" & CSafeStr(oProperty.Value)
80          TV1.Nodes.Add sParentKey, tvwChild, sPropKey, sPropText
        
        Next
    Next
    
    Set oProperties = Nothing
    Set oPropSets = Nothing
    Set oProperty = Nothing
    
    'To avoid selection bouncing
    Set TV1.SelectedItem = TV1.Nodes(1)
    TV1.SelectedItem.Expanded = False
    
    Exit Sub
fail:
    ErrHandlerRaise "RefreshPropertyTree"
End Sub

Private Sub cmdModify_Click()
    If m_oDoc Is Nothing Then Exit Sub
    If TV1.SelectedItem Is Nothing Then Exit Sub
    
    On Error Resume Next
    m_oDoc.Properties(m_ActiveClass)(m_ActiveProperty).Value = txtValue.Text
    If Err Then
        Err.Clear
        MsgBox "Can't change this property", vbInformation
        Exit Sub
    End If
    m_oDoc.Properties(m_ActiveClass).Save
    If Err Then
        Err.Clear
        MsgBox "Can't save this property", vbInformation
        Exit Sub
    End If
    
    TV1.SelectedItem.Text = m_ActiveProperty & "=" & txtValue.Text
End Sub

Private Sub cmdOpen_Click()
    If Trim(txtFile.Text) = "" Then Exit Sub
    AddInConst.OpenFolderWithFileSelection Trim(txtFile.Text)
End Sub

Private Sub Form_Load()
    DBG "AddIn: Form_Load"
End Sub

Private Sub Form_Resize()
    Picture2.Height = CZ(Me.ScaleHeight - Picture1.Height)
    DBG "AddIn: Resize"
    'THIS IS CRUCIAL FOR CORRECTLY REPAINT THE FORM AFTER RESIZING
    RedrawAll Me.hwnd
End Sub

Private Sub Form_Terminate()
    DBG "AddIn: Form_Terminate"
End Sub

Private Sub Form_Unload(Cancel As Integer)
    DBG "AddIn: Form_Unload"
    
    'Cleanup
    Set m_oApp = Nothing
    Set m_oDoc = Nothing
End Sub

Private Sub Picture1_Resize()
    cmdOpen.Left = CZ(Me.ScaleWidth - cmdOpen.Width - 20)
    txtFile.Width = CZ(Me.ScaleWidth - txtFile.Left - cmdOpen.Width - 60)
    
    'THIS IS CRUCIAL FOR CORRECTLY REPAINT THE FORM AFTER RESIZING
    RedrawAll Picture1.hwnd
End Sub

Private Sub Picture2_Resize()
    TV1.Move 80, 350, CZ(Picture2.ScaleWidth - 140), CZ(Picture2.ScaleHeight - 800)
    cmdModify.Top = TV1.Top + TV1.Height + 40
    cmdModify.Left = CZ(TV1.Left + TV1.Width - cmdModify.Width - 20)
    txtValue.Top = cmdModify.Top + 20
    txtValue.Width = CZ(Picture2.ScaleWidth - txtValue.Left - cmdModify.Width - 100)
    lblValue.Top = cmdModify.Top + 50

    'THIS IS CRUCIAL FOR CORRECTLY REPAINT THE FORM AFTER RESIZING
    RedrawAll Picture2.hwnd
End Sub

Private Sub TV1_Click()
    Dim oNode As Node
    
    If TV1.SelectedItem Is Nothing Then
        txtValue.Text = ""
        cmdModify.Enabled = False
        Exit Sub
    End If
    
    Set oNode = TV1.SelectedItem
    
    If oNode.Parent Is Nothing Then
        'Root Node
        txtValue.Text = ""
        txtValue.ToolTipText = "Click on a root node to open the property table"
        cmdModify.Enabled = False
        Exit Sub
    End If
    
    Dim sValue As String
    Dim v1 As Variant
    Dim v2 As Variant
    v1 = Split(oNode.Text, "=")
    v2 = Split(oNode.Key, "|")
    
    If UBound(v1) >= 1 Then
        m_ActiveProperty = CStr(v1(0))
        m_ActiveClass = CStr(v2(0))
        sValue = CStr(v1(1))
        cmdModify.Enabled = True
        txtValue.Text = sValue
        txtValue.ToolTipText = "[" & m_ActiveClass & "] - " & m_ActiveProperty
    End If
    
End Sub

